]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- handle missing binaries
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 %__rm                   /bin/rm --interactive=never
12
13 # Build system path macros.
14 #
15 %__autoconf             autoconf %{?debug:-Wall}
16 %__automake             automake -a -c -f --foreign
17 %__autopoint            autopoint --force
18
19 %__gettextize { \
20         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
21                 gettextize --copy --force --no-changelog; \
22         else \
23                 gettextize --copy --force --no-changelog --intl; \
24         fi; \
25         if [ ! -f po/Makevars ]; then \
26                 cp -f po/Makevars{.template,}; \
27         fi; \
28 }
29
30 %__glib_gettextize      glib-gettextize --copy --force
31 %__gnome_doc_common     gnome-doc-common --copy
32 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
33 %__gtkdocize            gtkdocize --copy
34 %__intltoolize          intltoolize --copy --force
35 %__libtoolize           libtoolize --copy --force
36
37 #       Path to top of build area.
38 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
39
40 #       The number of cvs changelog entries kept when building package.
41 %_buildchangelogtruncate 20
42
43 %dependencytracking     %{nil}
44
45 #       Relations between package names that cause dependency loops
46 #       with legacy packages that cannot be fixed. Relations are
47 #       specified as
48 #               p>q
49 #       where package p has a Requires: on something that package q Provides:
50 #
51 # XXX   Note: that there cannot be any whitespace within the string "p>q",
52 #       and that both p and q are package names (i.e. no version/release).
53 %_dependency_whiteout   %{nil}
54
55 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
58
59 #-----------------------------------------------------------------
60 #
61 # (re)definition of %{rpm*flags} with %filterout_* support
62 # BuildRequires:        awk
63 # BuildRequires:        rpmbuild(macros) >= 1.315
64 #
65 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
66 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
67 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
68 # %rpmldflags   = %optldflags - %filterout_ld
69 #
70 # Regular expressions are supported, but to avoid some character be treated
71 # as regular expression it must be escaped twice.
72
73 %filter_out                                             \
74         for (i = 1; i in I; i++) {      A=0;    \
75                 for (f in F) {                          \
76                         if (I[i] ~ "^" F[f] "$") A=1;   \
77                 };                                                      \
78                 if (!A) printf(I[i] FS);        \
79         }
80
81 %rpmcflags %(awk 'BEGIN {
82         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
83         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
84         %{filter_out}
85 }')
86
87 %rpmcxxflags %(awk 'BEGIN {
88         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
90         %{filter_out}
91 }')
92
93 %rpmldflags %(awk 'BEGIN {
94         split("%{?optldflags}",I);
95         split("%{?filterout_ld}",F)
96         %{filter_out}
97 }')
98
99 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100 # but, don't use it, better use gcc as linker
101 %ld_rpmldflags %(awk 'BEGIN {
102         split("%{rpmldflags}",F);
103         for (f in F) {
104                 s = F[f];
105                 if (s ~ /^-Wl,/) {
106                         s = substr(s,5);
107                         gsub(/,/," ",s);
108                 };
109                 printf(s FS);
110         };
111 }')
112
113 #-----------------------------------------------------------------
114 %configure2_13 { \
115  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
118  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
119  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
120  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
121  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
122  %{?__cc:CC="%{__cc}" ; export CC ; } \
123  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
124  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
125         --host=%{_target_platform} \
126         --prefix=%{_prefix} \
127         --exec-prefix=%{_exec_prefix} \
128         --bindir=%{_bindir} \
129         --sbindir=%{_sbindir} \
130         --sysconfdir=%{_sysconfdir} \
131         --datadir=%{_datadir} \
132         --includedir=%{_includedir} \
133         --libdir=%{_libdir} \
134         --libexecdir=%{_libexecdir} \
135         --localstatedir=%{_localstatedir} \
136         --sharedstatedir=%{_sharedstatedir} \
137         --mandir=%{_mandir} \
138         --infodir=%{_infodir} \
139         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
140         %{dependencytracking} \
141 }
142
143 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144 %__cmake        /usr/bin/cmake
145 %cmake { \
146 CC="%{__cc}" \
147 CXX="%{__cxx}" \
148 CFLAGS="%{rpmcflags}" \
149 CXXFLAGS="%{rpmcxxflags}" \
150 %{__cmake} \
151 }
152
153 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
154 %__scons        /usr/bin/scons
155 %scons { \
156 %{__scons} \
157         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158         CFLAGS="${CFLAGS:-%rpmcflags}" \
159         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160         FFLAGS="${FFLAGS:-%rpmcflags}" \
161         CPPFLAGS="${CPPFLAGS:-}" \
162         %{?__cc:CC="%{__cc}"} \
163         %{?__cxx:CXX="%{__cxx}"} \
164         libsuffix=%{_lib} \
165         prefix=%{_prefix} \
166 }
167
168 # waf. see waf.spec
169 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
170 %__waf  /usr/bin/waf
171 %waf { \
172 CC="%{__cc}" \
173 CXX="%{__cxx}" \
174 CPP="%{__cpp}" \
175 CFLAGS="%{rpmcflags}" \
176 CXXFLAGS="%{rpmcxxflags}" \
177 %{__waf} \
178 }
179
180 #----------------------------------------------------------------
181 #%configure_cache 0
182 %configure_cache_file   %{buildroot}.configure.cache
183
184 %configure {./configure \
185         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186         CFLAGS="${CFLAGS:-%rpmcflags}" \
187         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
188         FFLAGS="${FFLAGS:-%rpmcflags}" \
189         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
190         CPPFLAGS="${CPPFLAGS:-}" \
191         %{?__cc:CC="%{__cc}"} \
192         %{?__cxx:CXX="%{__cxx}"} \
193         --host=%{_target_platform} \
194         --build=%{_target_platform} \
195         --prefix=%{_prefix} \
196         --exec-prefix=%{_exec_prefix} \
197         --bindir=%{_bindir} \
198         --sbindir=%{_sbindir} \
199         --sysconfdir=%{_sysconfdir} \
200         --datadir=%{_datadir} \
201         --includedir=%{_includedir} \
202         --libdir=%{_libdir} \
203         --libexecdir=%{_libexecdir} \
204         --localstatedir=%{_localstatedir} \
205         --sharedstatedir=%{_sharedstatedir} \
206         --mandir=%{_mandir} \
207         --infodir=%{_infodir} \
208         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
209         %{dependencytracking} \
210         %{?configure_cache:--cache-file=%{configure_cache_file}} \
211 }
212
213 # overload to insert debuginfo package
214 %prep \
215 %if 0%{?_enable_debug_packages}\
216 %{debug_package}\
217 %endif\
218 %%prep\
219 %{nil}
220
221 # Location of autoconf macros
222 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
223
224 # Location of omf files
225 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
226
227 # Location of pkgconfig files
228 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
229
230 # Location of desktop files
231 %_desktopdir    /usr/share/applications
232 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
233
234 # Location of pixmaps for applnk/desktop files
235 %_pixmapsdir    /usr/share/pixmaps
236
237 # Location of themable icons for applnk/desktop files
238 %_iconsdir      /usr/share/icons
239
240 # Location of fonts directories
241 %_fontsdir      /usr/share/fonts
242
243 # Location of Gtk and associated libraries documentation
244 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
245
246 # Location of KDE documentation
247 %_kdedocdir     %{_defaultdocdir}/kde/HTML
248
249 # unsermake script
250 %__unsermake /usr/share/unsermake/unsermake
251
252 # Current date
253 %date           %(LC_ALL="C" date +"%a %b %d %Y")
254
255 # tmp directory
256 %tmpdir         %{expand:%%global tmpdir %{lua:print(os.getenv("TMPDIR") or "/tmp")}}%{tmpdir}
257
258 # Example files, programs, scripts...
259 %_examplesdir   /usr/src/examples
260
261 # Alternative kernel type/version
262 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
263
264 # The directory holding Linux kernel sources
265 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
266
267 # If non-empty "debug" macro defined, add "dbg" suffix to release number
268 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
269
270 # Requires name = version-release
271 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
272
273 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
274 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
275 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
276 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
277 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
278 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
279
280 # XXX: why epoch 0 is stripped?
281 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
282 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
283
284 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
285
286 # kernel version-release handling
287 %__kernel_ver    %{expand:%%global __kernel_ver %(VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))}%__kernel_ver
288 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
289 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
290 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
291 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
292
293 # sgml macros
294 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
295 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
296 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
297 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
298 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
299 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
300 %docbook_sgmlcat_fix() { for l in \
301 '' \
302 '  -- default decl --' \
303 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
304 '  -- hacks for opensp --' \
305 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
306 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
307 '' \
308 ; do echo $l; done >> %1 \
309 }
310
311 # vim - "
312
313 # minimum file size needed for compressed documents.
314 # just smaller files than this get larger when compressed.
315 # some stats:
316 # - 0 byte file compressed was 25 bytes .gz
317 # - 39 byte file was compressed as 57
318 # - with test/test.spec@man 158 byte file was compressed also 158
319 %_min_compress_bytes    159
320
321 #-----------------------------------------------------------------
322 # find and gzip all files in %{_mandir} and %{infodir}
323 #
324 # Requires: xargs, find
325 #
326 #%no_install_post_compress_docs 1
327 %__spec_install_post_compress_docs { \
328 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
329         for i in /usr/share/man /usr/X11R6/man; do \
330                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
331                         echo "Compress man pages: $i"; \
332                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
333                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
334                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
335                                 m=$(readlink $a); \
336                                 rm -f $a; \
337                                 echo .so ${m##*/} > $a; \
338                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
339                         done; \
340                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
341                 fi; \
342         done; \
343         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
344                 echo "Compress info pages: %{_infodir}"; \
345                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
346                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
347                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
348         fi; \
349 }; __spec_install_post_compress_docs } }
350
351 #-----------------------------------------------------------------
352 # Strip executable binaries and shared object files
353 #
354 # Requires: find, awk, strip, cut, xargs
355 #
356 # Special macros which affect this process:
357 #%no_install_post_strip 1               # disable stripping at all
358 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
359 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
360 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
361 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
362 #
363 %__spec_install_post_strip {%{!?debug: \
364 %{!?no_install_post_strip:__spec_install_post_strip() { \
365 if [ -d "$RPM_BUILD_ROOT" ]; then \
366         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
367                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
368                 if [ "$modulelist" ]; then \
369                         modulecount=$(echo "$modulelist" | wc -l); \
370                         printf "Stripping %d kernel modules..." $modulecount; \
371                         echo "$modulelist" | xargs -l512 chmod u+w; \
372                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
373                         echo "DONE"; \
374                 fi; \
375         fi; \
376         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
377         if [ -n "$filelist" ]; then \
378                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
379                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
380                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
381                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
382                 if [ -n "$elfexelist" ]; then \
383                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
384                         chmod u+w $elfexelist; \
385                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
386                         echo "DONE"; \
387                 fi; \
388                 if [ -n "$elfsharedlist" ]; then \
389                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
390                         chmod u+w $elfsharedlist; \
391                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
392                         echo "DONE"; \
393                 fi; \
394                 if [ -n "$archiveslist" ]; then \
395                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
396                         chmod u+w $archiveslist; \
397                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
398                         echo "DONE"; \
399                 fi; \
400         fi; \
401     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
402     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
403     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
404         if [ -n "$filelist_all" ]; then \
405                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
406                 chmod u+w $filelist_all; \
407                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
408                 echo "DONE"; \
409         fi; \
410         if [ -n "$filelist_unneeded" ]; then \
411                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
412                 chmod u+w $filelist_unneeded; \
413                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
414                 echo "DONE"; \
415         fi; \
416         if [ -n "$filelist_debug" ]; then \
417                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
418                 chmod u+w $filelist_debug; \
419                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
420                 echo "DONE"; \
421         fi; \
422 fi; }; __spec_install_post_strip } } }
423
424 #-----------------------------------------------------------------
425 # remove all RPATH from executable binaries and shared object files
426 #
427 # Requires: find, awk, cut, xargs, chrpath, uname
428 #
429 # Special macros which affect this process
430 #%no_install_post_chrpath       1       # disable chrpath at all
431 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
432 #
433 %__spec_install_post_chrpath {%{!?debug: \
434 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
435 if [ -d "$RPM_BUILD_ROOT" ]; then \
436         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
437         if [ -n "$files" ]; then \
438                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
439         fi; \
440         if [ -n "$objs" ]; then \
441                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
442                 echo "$objs" | \
443                 while read file; do \
444                         rpath= ; \
445                         chmod u+w "$file"; \
446                         for dir in `chrpath -l "$file" | \
447                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
448                                         case $dir in \
449                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
450                                                 echo "remove-rpath: $dir in $file"; \
451                                                 ;; \
452                                         * ) \
453                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
454                                                 else rpath="$rpath:$dir" ; fi ; \
455                                                 ;; \
456                                         esac ; \
457                         done ; \
458                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
459                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
460                 done; \
461         fi; \
462 fi; }; __spec_install_post_chrpath } } }
463
464 #-----------------------------------------------------------------
465 # Find and gzip all kernel modules
466 #
467 # Requires: find
468 #
469 #%no_install_post_compress_modules      1
470 %__spec_install_post_compress_modules { \
471 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
472         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
473                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
474                 if [ "$q" ]; then \
475                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
476                         echo "$q" | xargs -r %{__gzip} -9nf; \
477                         echo "DONE"; \
478                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
479                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
480                 fi; \
481         fi; \
482 }; __spec_install_post_compress_modules } }
483
484 # Remove common Perl files we don't package
485 %__spec_install_post_perl_clean {\
486 %{!?no_install_post_perl_clean: \
487 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
488 } }
489
490 #-----------------------------------------------------------------
491 # Update GConf2 schemas
492 #
493 # Requires: GConf2
494 #
495 %gconf_schema_install() \
496         umask 022; \
497         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
498 %{nil}
499
500 %gconf_schema_uninstall() \
501 if [ $1 = 0 ]; then \
502         umask 022; \
503         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
504 fi; \
505 %{nil}
506
507 #-----------------------------------------------------------------
508 # Update desktop MIME database
509 # requires: desktop-file-utils
510 #
511 %update_desktop_database_post() \
512         umask 022; \
513         /usr/bin/update-desktop-database -q; \
514 %{nil}
515
516 %update_desktop_database_postun() \
517 if [ "$1" = "0" ]; then \
518         umask 022; \
519         /usr/bin/update-desktop-database -q; \
520 fi; \
521 %{nil}
522
523 #-----------------------------------------------------------------
524 # Update shared MIME info database
525 # requires: shared-mime-info
526 #
527 %update_mime_database() \
528         umask 022; \
529         /usr/bin/update-mime-database %{_datadir}/mime; \
530 %{nil}
531
532 #-----------------------------------------------------------------
533 # Update icon cache
534 # requires: gtk+
535 #
536 %update_icon_cache() \
537         umask 022; \
538         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
539 %{nil}
540
541 #-----------------------------------------------------------------
542 # Update scrollkeeper database
543 # requires: scrollkeeper
544 #
545 %scrollkeeper_update_post() \
546         /usr/bin/scrollkeeper-update -q; \
547 %{nil}
548
549 %scrollkeeper_update_postun() \
550 if [ "$1" = "0" ]; then \
551         /usr/bin/scrollkeeper-update -q; \
552 fi; \
553 %{nil}
554
555 #-----------------------------------------------------------------
556 # post %install sequence:
557 # - autodeps exceptions
558 # - compress all man and info pages,
559 # - strip all ELF executables and ELF shared objects if not %debug.
560 # - compress kernel modules if any
561
562 ###################################################################
563 # Requires/Provides automation
564 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
565 #
566 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
567 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
568 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
569 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
570 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
571
572 #%_noautocompressdoc    %{nil}
573 #
574 %_missing_doc_files_terminate_build     1%{nil}
575 %_unpackaged_files_terminate_build      %{nil}
576 # (X)emacs support
577 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
578 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
579 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
580
581 %__php_provides %{nil}
582 %__php_requires %{nil}
583 %__perl_provides %{nil}
584 %__perl_requires %{nil}
585 %__mono_provides %{nil}
586 %__mono_requires %{nil}
587
588 # Perl specific macro definitions.
589 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
590 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
591 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
592 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
593 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
594 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
595
596 # Ruby
597 %__ruby                         /usr/bin/ruby
598 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
599 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
600 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
601 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
602 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
603 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
604 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
605 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
606 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
607 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
608
609 %php_pear_dir           /usr/share/pear
610 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
611 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
612 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
613
614 # extract php/zend api versions
615 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
616 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
617 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
618 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
619 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
620 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
621 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
622
623 # helper macro
624 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
625
626 # macros for public use
627 # for php extensions (php-pecl)
628 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
629 %{__php_api_requires zend_module_api} \
630 %{__php_api_requires -v %php_major_version debug php_debug} \
631 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
632
633 # for zend extensions
634 %requires_zend_extension %{__php_api_requires zend_module_api} \
635 %{__php_api_requires zend_extension_api} \
636 %{__php_api_requires -v %php_major_version debug php_debug} \
637 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
638
639 # for php pdo modules (php-pecl-PDO_*)
640 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
641
642 # for using PHP post scripts. for PHP >= 5.0
643 %php_webserver_restart \
644 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
645 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
646 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
647         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
648         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
649                 %service -q php-fcgi restart \
650         fi \
651 fi \
652 %{nil}
653
654 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
655 %php4_webserver_restart \
656 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
657 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
658 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
659         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
660         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
661                 %service -q php-fcgi restart \
662         fi \
663 fi \
664 %{nil}
665
666
667 # X.org helper macros
668 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
669 #
670 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
671 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
672 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
673 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
674 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
675
676 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
677 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
678 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
679 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
680 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
681 %{__xorg_abi_requires font xorg_xserver_font_abi}
682 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
683 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
684
685 # Python specific macro definitions.
686 # python main version
687 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" || echo ERROR)}%py_ver
688
689 # directories
690 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" || echo ERROR)}%py_prefix
691 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
692 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
693 %py_incdir              /usr/include/python%{py_ver}
694 %py_sitedir             %{py_libdir}/site-packages
695 %py_sitescriptdir %{py_scriptdir}/site-packages
696 %py_dyndir              %{py_libdir}/lib-dynload
697
698 # pure python modules compilation
699 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
700
701 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
702
703 # Software written in Python language require Python with main version
704 %pyrequires_eq() Requires:      %1
705
706 # Hardlink binary identical .pyc and .pyo files
707 # (idea by glen <at> pld-linux <dot> org)
708 %__spec_install_post_py_hardlink {\
709 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
710 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
711         b="${a%.pyc}.pyo"; \
712         if cmp -s "$a" "$b"; then \
713                 ln -f "$a" "$b"; \
714         fi; \
715 done \
716 }; __spec_install_post_py_hardlink } }
717
718 # remove python sources, so that check-files won't complain
719 # (idea by glen <at> pld-linux <dot> org)
720 %py_postclean() \
721 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
722  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
723 done \
724 %{nil}
725
726 # depmod macro
727 %depmod() { \
728 umask 022; \
729 if [ -e /boot/System.map-%1 ]; then \
730         /sbin/depmod -a -F /boot/System.map-%1 %1; \
731 else \
732         if [ -e /boot/System.map ]; then \
733                 /sbin/depmod -a -F /boot/System.map %1; \
734         else \
735                 /sbin/depmod -a %1; \
736         fi \
737 fi; \
738 }
739
740 # XMMS specific macros
741 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
742 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
743 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
744 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
745 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
746 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
747 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
748 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
749 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
750 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
751
752 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
753
754 # user/group checking macros
755 #
756 # Usage:
757 #       %userremove myuser
758 #
759 %userremove     /usr/lib/rpm/user_group.sh user del
760 %groupremove    /usr/lib/rpm/user_group.sh group del
761 #
762 # Usage:
763 #       if %usertestrm myuser; then
764 #               /usr/sbin/userdel -r myuser
765 # Note:
766 #       use these macros only if you need to call userdel/groupdel with
767 #       a non-standard option or take an extra action; otherwise use the
768 #       %userremove/%groupremove macros
769 #
770 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
771 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
772 # user group membership management macros
773 #
774 # Usage:
775 #       %addusertogroup myuser agroup
776 #
777 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
778
779 # banner support (useful in {pre,post}{,un} and triggers)
780 #
781 # Usage:
782 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
783 # the banner text, the banner text
784 # the banner text, and following line
785 #EOF
786 # You can use any form of here-document, <<'EOF' <<-EOT will do.
787 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
788 #
789 # -a   - append to the banner
790 # -e   - send to stderr instead of stdout
791 # -n   - no show banner (overrides -t)
792 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
793 #
794 # Tests:
795 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
796 # rpm -E 'date | %banner -e banner' > m; sh -x m
797 #
798 %banner(aent:) ( \
799 RPM_SCRIPTVERBOSITY=5 \
800 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
801 if [ -x /usr/bin/banner.sh ]; then \
802         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
803 else \
804         CMD="cat%{-e: >&2}" \
805 fi \
806 eval $CMD %{?2:%2}%{?3: %3}) \
807 %{nil}
808
809 # useradd/groupadd macros
810 # Author: Elan Ruusamäe <glen@pld-linux.org>
811 #
812 # Usage:
813 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
814 #   [-g initial_group] [-G group[,...]] login
815 #
816 #  -u uid. REQUIRED
817 #  -g gid/group. REQUIRED
818 #  -s defaults to /bin/false
819 #  -d defaults to /usr/share/empty
820 #  -c No default
821 #  -r is accepted but ignored (it's always set)
822 #  -k skeleton dir. defaults to /usr/share/empty
823 # rpm specific flags
824 #  -P package name. defaults to %{name}
825 #
826 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
827 %{!-u:%{error:useradd: Required argument -u missing}} \
828 %{!-g:%{error:useradd: Required argument -g missing}} \
829 %{!?1:%{error:useradd: Required parameter login missing}} \
830 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
831         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
832                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
833                 exit 1 \
834         fi \
835 else \
836         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
837         /usr/sbin/useradd \\\
838                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
839                 -u %{-u*} \\\
840                 -r \\\
841                 -d %{-d*}%{!-d:/usr/share/empty} \\\
842                 -s %{-s*}%{!-s:/bin/false} \\\
843                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
844                 -g %{-g*} \\\
845                 %{-M} \\\
846                 %{-G:-G %{-G*}} \\\
847                 %{expand:%{%{#}}} 1>&2 || exit $? \
848         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
849 fi;
850
851 # Usage:
852 #   %groupadd [-P package] [-g gid] group
853 #
854 # -g gid. REQUIRED
855 #
856 # Sample:
857 #   %groupadd -P %{name}-base -g %{gid} %{name}
858
859 %groupadd(g:P:rfo)      \
860 %{!-g:%{error:groupadd: Required argument -g missing}} \
861 %{!?1:%{error:groupadd: Required parameter group missing}} \
862 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
863         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
864                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
865                 exit 1 \
866         fi \
867 else \
868         echo "Adding group %{1} GID=%{-g*}." \
869         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
870         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
871 fi;
872
873 # webapp macros
874 # Author: Elan Ruusamäe <glen@pld-linux.org>
875 #
876 # The config is installed/removed inside trigger, this means that you can any
877 # time install apache1/apache/lighttpd package and the configuration file is
878 # updated. if you don't need the config for various reason for specific
879 # webserver, just remove the symlink from config directory using webapp
880 # program. the trigger will not recreate the symlink on upgrades. In other
881 # words the config is linked to webserver config directory on first install of
882 # PACKAGE or WEBSERVER.
883 #
884 # Add package's webserver config to webserver webapps dir.
885 # Usage:
886 #   %webapp_register WEBSERVER WEBAPP
887 #
888 %webapp_register() \
889 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
890 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
891         /usr/sbin/webapp register %1 %2\
892 fi\
893 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
894 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
895         %{expand:%service -q %%1 reload}\
896 fi\
897 %{nil}
898
899 # Remove package's config from webserver webapps dir.
900 # Usage:
901 #   %webapp_register [-f] WEBSERVER WEBAPP
902 %webapp_unregister(f) \
903 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
904 # remove link if either of the packages are gone \
905 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
906         /usr/sbin/webapp unregister %1 %2\
907         %{expand:%service -q %%1 reload}\
908 fi \
909 %{nil}
910
911 # service macro.
912 # Author: Elan Ruusamäe <glen@pld-linux.org>
913 #
914 # calls usual service restart on package %post, but skips the restart if
915 # administrator has disabled automatic service restarts in either global
916 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
917 #
918 # Usage:
919 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
920 #
921 #  -q be silent when service isn't started (for scriplets restaring other package's services)
922 #
923 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
924
925
926 # Java macros. based on jpackage macros.java
927 #
928 # Root directory where all Java VMs/SDK/JREs are installed.
929 %_jvmdir                %{_libdir}/jvm
930
931 # Root directory where all Java VMs/SDK/JREs expose their jars
932 %_jvmjardir             %{_libdir}/jvm-exports
933
934 # Root directory for all Java VM/SDK/JRE's private things.
935 %_jvmprivdir    %{_libdir}/jvm-private
936
937 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
938 %_jvmlibdir             %{_libdir}/jvm
939
940 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
941 %_jvmdatadir    %{_datadir}/jvm
942
943 # Root directory for all configurations parts of Java VM/SDK/JRE's
944 %_jvmsysconfdir %{_sysconfdir}/jvm
945
946 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
947 %_jvmcommonlibdir       %{_libdir}/jvm-common
948
949 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
950 %_jvmcommondatadir      %{_datadir}/jvm-common
951
952 # Root directory for all common configurations parts of Java VM/SDK/JRE's
953 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
954
955 # Directory where arch-specific (JNI) version-independent jars are installed.
956 %_jnidir                %{_libdir}/java
957
958 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
959
960 %ant                    JAVA_HOME=%{java_home} ant
961 %jar                    %{java_home}/bin/jar
962 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
963 %javac                  %{java_home}/bin/javac
964 %javadoc                %{java_home}/bin/javadoc
965
966 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
967
968 %jpackage_script() \
969 install -d $RPM_BUILD_ROOT%{_bindir}\
970 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
971 #!/bin/sh\
972 #\
973 # %{name} script\
974 # JPackage Project <http://www.jpackage.org/>\
975 \
976 # Source functions library\
977 . %{_javadir}-utils/java-functions\
978 \
979 # Source system prefs\
980 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
981     . %{_sysconfdir}/java/%{name}.conf\
982 fi\
983 \
984 # Source user prefs\
985 if [ -f $HOME/.%{name}rc ]; then\
986     . $HOME/.%{name}rc\
987 fi\
988 \
989 # Configuration\
990 MAIN_CLASS=%1\
991 BASE_FLAGS=%2\
992 BASE_OPTIONS=%3\
993 BASE_JARS="%(echo %4 | tr ':' ' ')"\
994 \
995 # Set parameters\
996 set_jvm\
997 set_classpath $BASE_JARS\
998 set_flags $BASE_FLAGS\
999 set_options $BASE_OPTIONS\
1000 \
1001 # Let's start\
1002 run "$@"\
1003 EOF
1004
1005 # jpackage 1.7
1006 # Directory for maven depmaps
1007 #
1008 %_mavendepmapdir /etc/maven
1009 %_mavendepmapfragdir /etc/maven/fragments
1010
1011 #
1012 # add_to_depmap adds an entry to the depmap. The arguments are:
1013 #
1014 # %1 the original groupid
1015 # %2 the original artifact id
1016 # %3 the version
1017 # %4 the new groupid
1018 # %5 the new artifactid
1019 #
1020
1021 %add_to_maven_depmap() \
1022 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1023 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1024 <dependency>\
1025     <maven>\
1026         <groupId>%1</groupId>\
1027         <artifactId>%2</artifactId>\
1028         <version>%3</version>\
1029     </maven>\
1030     <jpp>\
1031         <groupId>%4</groupId>\
1032         <artifactId>%5</artifactId>\
1033         <version>%3</version>\
1034     </jpp>\
1035 </dependency>\
1036 \
1037 EOF\
1038 %{nil}
1039
1040 #==============================================================================
1041 #
1042 # update_maven_depmap updates the main maven depmap
1043 #
1044 %update_maven_depmap() \
1045 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1046 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1047 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1048 fi\
1049 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1050
1051
1052 # PEAR install macros
1053 # Author: Elan Ruusamäe <glen@pld-linux.org>
1054 #
1055 # Usage:
1056 #       %%pear_package_setup [-a #] [-n FMT]
1057 #
1058 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1059 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1060 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1061 #
1062 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1063 # destination hierarchy. you should copy the tree to buildroot after
1064 # patching/reorganizing with %%pear_package_install.
1065 #
1066 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1067 # line endings.
1068 #
1069 # the pear install process output is recorded to install.log, you should put it
1070 # to %%doc for later debug or just for information.
1071 #
1072 # additionally additional-packages.txt is produced if it was detected that the
1073 # package has optional dependencies. the file format is suitable of displaying
1074 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1075 # automatically added for this file.
1076
1077
1078 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1079 %__pear_install_log \
1080 tee install.log \
1081 # make post message of optional packages \
1082 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1083 if [ -s optional-packages.txt ]; then \
1084         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1085 else \
1086         rm -f optional-packages.txt \
1087 fi \
1088 %{nil}
1089
1090 # command invoking pear cli
1091 %__pear /usr/bin/pear
1092
1093 %pear_install(a:n:zD) \
1094 %__pear \\\
1095         -c pearrc \\\
1096         -d doc_dir=/docs \\\
1097         -d php_dir=%{php_pear_dir} \\\
1098         -d bin_dir=%{_bindir} \\\
1099         -d data_dir=%{php_pear_dir}/data \\\
1100         -d test_dir=%{php_pear_dir}/tests \\\
1101         install \\\
1102         --packagingroot=%{builddir} \\\
1103         --offline \\\
1104         --nodeps \\\
1105         %{-f:--force} \\\
1106         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1107 %{nil}
1108
1109 # The main macro.
1110 # using this macro will append optional-packages.txt to the nocompressdoc list
1111 # as it's displayed to user after package install. and adding additional gzip
1112 # dep is just waste ;)
1113 %pear_package_setup(a:n:zD) \
1114 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1115 %define builddir %{_builddir}/%{srcdir} \
1116 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1117 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1118 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1119 %pear_install \
1120 %{-z:cd ..} \
1121 cat %{-z:$_N/}.install.log | %__pear_install_log \
1122 \
1123 # undos sources \
1124 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1125 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1126 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1127 %{nil}
1128
1129 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1130 # Author: Elan Ruusamäe <glen@pld-linux.org>
1131 %pear_package_install() \
1132 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1133 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1134 # help the developer out a little: \
1135 if [ -f _noautoreq ]; then \
1136         echo "AutoReqdep detected:" \
1137         echo "_noautoreq $(cat _noautoreq)" \
1138 fi \
1139 %{nil}
1140
1141
1142 # Register OpenLDAP schema.
1143 # Author: Elan Ruusamäe <glen@pld-linux.org>
1144 #
1145 # Usage:
1146 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1147 #
1148 #  -d specify dependant schemas, separated by comma
1149 #
1150 %openldap_schema_register(d:) \
1151 for schema in %*; do \
1152         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1153                 %{__sed} -i -e " \
1154                         /^include.*local.schema/{ \
1155                                 iinclude\\t     $schema\
1156                         } \
1157                 " /etc/openldap/slapd.conf \
1158         fi \
1159 done \
1160 # enable dependant schemas \
1161 if [ "%{-d*}" ]; then \
1162         %{__sed} -i -e ' \
1163         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1164                 s/^#// \
1165         }' /etc/openldap/slapd.conf \
1166 fi \
1167 %{nil}
1168
1169 # Unregister OpenLDAP schema.
1170 # Author: Elan Ruusamäe <glen@pld-linux.org>
1171 #
1172 # Usage:
1173 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1174 #
1175 %openldap_schema_unregister() \
1176 for schema in %*; do \
1177         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1178                 %{__sed} -i -e " \
1179                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1180                 # for symmetry it would be nice if we disable enabled schemas in post, \
1181                 # but we really can not do that, it would break something else. \
1182                 " /etc/openldap/slapd.conf \
1183         fi \
1184 done \
1185 %{nil}
1186
1187 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1188
1189
1190 # Build modules for kernels 2.6
1191 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1192 #
1193 # Usage:
1194 #       %build_kernel_modules -m <modules> -C <directory>
1195 #
1196 #  remember that proper Makefile is still required
1197 # Options:
1198 #  -m <modules> (required) -- comma-separated list of modules to save,
1199 #               without .ko extension, may be placed in subdirectory
1200 #  -C <directory> -- change to <directory> before doing anything
1201 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1202 #  -c -- do not execute make clean
1203 #  <additional arguments> -- all additional arguments will be passed to
1204 #               make modules
1205 #
1206 # Additional patching supported via here document. Try:
1207 #       %build_kernel_modules -m module <<'EOF'
1208 #       your patch script here
1209 #       EOF
1210 # Don't use it unless patching depends on config options.
1211
1212 # Developer note: don't touch it unless you know how to handle '\'.
1213 # - \ in script expands to nothing
1214 # - \\\ in script expands to \
1215 # - \\\ inside definition expands to nothing
1216 # - \\\\\\\ inside definition expands to \
1217 # - in last line \ has to touch arguments so arguments passing
1218 #   in new lines (using \) will be supported
1219
1220 %build_kernel_modules(p:P:m:C:c)                                                                        \
1221 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1222                                                                                                                                         \
1223 %define Opts                                                                                                            \\\\\\\
1224 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1225         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1226         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1227         %else                                                                                                                   \\\
1228         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1229         %endif                                                                                                                  \\\
1230 %else                                                                                                                           \\\
1231         CC="%{kgcc}"                                                                                                    \\\
1232 %endif                                                                                                                          \
1233 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1234                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1235                                                                                                                                         \
1236 %{?-C:cd %{-C*}}                                                                                                        \
1237 compile() {                                                                                                                     \
1238         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1239         set -e -x                                                                                                               \
1240         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1241                                                                                                                                         \
1242 for cfg in ${cfgs:-dist}; do                                        \
1243         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1244                                                                                                                                         \
1245         rm -rf o                                                                                                                \
1246         install -d o/include/linux                                                                              \
1247         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1248         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1249         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1250                                                                                                                                         \
1251         set +x                                                                                                                  \
1252         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1253         set -x                                                                                                                  \
1254                                                                                                                                         \
1255         %if %{with dist_kernel}                                                                                 \
1256                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1257                         %{-p*} %{-P*}                                                                                   \\\
1258                         %{MakeOpts}                                                                                             \
1259         %else                                                                                                                   \
1260                 install -d o/include/config                                                                     \
1261                 touch o/include/config/MARKER                                                           \
1262                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1263         %endif                                                                                                                  \
1264                                                                                                                                         \
1265         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1266                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1267                 ${1+"$@"}                                                                                                       \\\
1268                 M=$PWD %{MakeOpts}}                                                                                     \
1269                                                                                                                                         \
1270         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1271                 ${1+"$@"}                                                                                                       \\\
1272                 M=$PWD %{MakeOpts}                                                                                      \
1273                                                                                                                                         \
1274         for MODULE in {%{-m*},}; do                                                                             \
1275                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1276         done                                                                                                                    \
1277 done                                                                                                                            \
1278 %{?-C:cd -}                                                                                                                     \
1279 }                                                                                                                                       \
1280 compile %{*}\
1281 %{nil}
1282
1283
1284 # Install kernel modules built by %build_kernel_modules
1285 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1286 #
1287 # Usage:
1288 #       %install_kernel_modules -m <modules> -d <directory>
1289 #
1290 # Options:
1291 #  -m <modules> (required) -- comma-separated list of modules to install,
1292 #               without .ko extension, may be placed in subdirectory
1293 #  -d <directory> (required) -- in what subdirectory modules should be
1294 #               installed (eg. misc, kernel/drivers/net)
1295 #  -s <suffix> -- suffix to use when installing modules, useful when module
1296 #               with same name exists in kernel already
1297 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1298 #               for defining aliases, only useful with -s
1299
1300 %install_kernel_modules(m:d:s:n:)                                                                       \
1301 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1302 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1303 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1304                                                                                                                                         \
1305 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1306 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1307                                                                                                                                         \
1308 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1309                                                                                                                                         \
1310 for MODULE in {%{-m*},}; do                                                                                     \
1311         [ -n "${MODULE}" ] || continue                                                                  \
1312         for cfg in ${cfgs:-dist}; do                                    \
1313                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1314                 MNAME=${MODULE##*/}                                                                                     \
1315                 install -D ${MODULE}-$cfg.ko                                                            \\\
1316                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1317                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1318                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1319                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1320         done                                                                                                                    \
1321 done                                                                                                                            \
1322 %{nil}
1323
1324 # patchset macros
1325 # Author: Elan Ruusamäe <glen@pld-linux.org>
1326 #
1327 # Usage:
1328 #   %patchset_source -f <seq(1) format> <start> [<end>]
1329 #   %patchset_patch <start> [<end>]
1330 #
1331 # If <end> is omited, it is assumed to be <start>.
1332 #
1333 # For example in preamble:
1334 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1335 # and in %prep:
1336 #  %patchset_patch 33 44
1337
1338 # generate SourceX urls from range START STOP
1339 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1340 # The sources start from 10000
1341 %patchset_source(f:b:) %(
1342         base=%{-b*}%{!-b*:10000};
1343         start=$(expr $base + %1);
1344         end=$(expr $base + %{?2}%{!?2:%{1}});
1345         # we need to call seq twice as it doesn't allow two formats
1346         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1347         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1348         paste %{tmpdir}/__ps{1,2};
1349         rm -f %{tmpdir}/__ps{1,2};
1350 ) \
1351 %{nil}
1352
1353 # apply sources from %patchset_source
1354 # -p specify -pX for %patch line
1355 # -b base offset: defaults to 10000
1356 %patchset_patch(f:p:b:) %(
1357         base=%{-b*}%{!-b*:10000};
1358         start=$(expr $base + %1);
1359         end=$(expr $base + %{?2}%{!?2:%{1}});
1360         echo ": patchset_patch %1%{?2: to %2}";
1361         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1362 ) \
1363 %{nil}
1364
1365 # browser plugins v2
1366 # Author: Elan Ruusamäe <glen@pld-linux.org>
1367 #
1368 # Usage:
1369 #       %browser_plugins_add_browser <name> -p <plugindir>
1370 #
1371 #  <name> (required) -- name of the browser. usually %{name}.
1372 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1373 #  -b -- default blacklists
1374 #  -a <arch> override arch
1375 #
1376 # Example:
1377 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1378
1379 %_browserpluginsconfdir         /etc/browser-plugins
1380 %_browserpluginsdir                     %{_libdir}/browser-plugins
1381 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1382
1383 %browser_plugins_add_browser(p:b:a:) \
1384         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1385         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1386         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1387         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1388         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1389         %{-b:cat >> $blacklist_file %{-b*}} \
1390 %{nil}
1391
1392 # Helper for LUA.
1393 # split string separated by space into quoted list
1394 #
1395 # Author: Elan Ruusamäe <glen@pld-linux.org>
1396 #
1397 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1398 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1399
1400 # adjust /etc/shells by adding and removing shells from there
1401 # Author: Elan Ruusamäe <glen@pld-linux.org>
1402 #
1403 # Usage:
1404 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1405 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1406 #
1407 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1408
1409 %add_etc_shells(p) %{-p:<lua>}\
1410 t = {}\
1411 f = io.open("/etc/shells", "r")\
1412 if f then\
1413         for l in f:lines() do t[l]=l; end\
1414         f:close()\
1415 end\
1416 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1417         if not t[s] then\
1418                 print("Adding "..s.." to /etc/shells")\
1419                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1420         end\
1421 end\
1422 %{nil}
1423
1424 %remove_etc_shells(p) %{-p:<lua>}\
1425 %{-p:if arg[2] == 0 then}\
1426         t = {}\
1427         f = io.open("/etc/shells", "r")\
1428         if f then\
1429                 for l in f:lines() do t[l]=l; end\
1430                 f:close()\
1431         end\
1432         for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1433                 print("Removing "..l.." from /etc/shells")\
1434                 t[l] = nil\
1435         end\
1436         s=""\
1437         for _, l in pairs(t) do\
1438                 s=s..l.."\\n"\
1439         end\
1440         io.open("/etc/shells", "w"):write(s)\
1441 %{-p:end} \
1442 %{nil}
1443
1444 # vim:ts=4 sw=4 noet syn=spec
This page took 0.268956 seconds and 4 git commands to generate.